#pragma once
#include "ErrorDefine.h"
typedef struct
{
    STRUCT_ENUM_ERROR_TYPE enumError;
    LPCTSTR lpszErrorName;
}STRUCT_ERROR;

CONST STRUCT_ERROR ERROR_INFORMATION[] =
{
    {_ERROR_SUCCESS, _T("No error!")},
    {_ERROR_COMMONFUNC_CMD, _T("Invalid command table!")},
    {_ERROR_COMMONFUNC_OUTPUT, _T("No output buffer!")},
    {_ERROR_COMMONFUNC_POLLINGFAIL, _T("Polling Mcu Register Cmd Fail!")},
    {_ERROR_COMM_NOTEXIST, _T("Communication type is not found!")},
    {_ERROR_COMM_LOADDLL_FAIL, _T("Load communication dll failed!")},
    {_ERROR_COMM_NO_INITIAL, _T("DLL is not initialized")},
    {_ERROR_COMM_PARAMETER, _T("Unsupport parameter!")},
    {_ERROR_COMM_UNSUPPORT_DEBUGMODE, _T("Unsupport debug mode!")},  
    {_ERROR_COMM_SET_IICADDR, _T("Set IIC Slave address failed!")},  
    {_ERROR_COMM_ENTER_ISP_MODE, _T("Enter Isp Mode fail!")},
    {_ERROR_COMM_UNSUPPORT_MCUREGACCESSMODE, _T("Unsupport Mcu Register Accecc mode!")},
    {_ERROR_COMM_AUTO_DETECT_SLAVE_ADDRESS_FAIL, _T("Auto Detect Slave Address Fail!")},
    {_ERROR_COMM_DDCCI_READ_CHECKSUM_ERROR, _T("DDCCI Read Checksum Error!")},
    {_ERROR_COMM_DDCCI_READ_SLAVE_ADDRESS, _T("DDCCI Read Slave Address Error!")},
    {_ERROR_COMM_DDCCI_CMD_ERROR, _T("DDCCI Cmd Error!")},
    {_ERROR_COMM_I2C_MASTER_BUFFER_SIZE, _T("I2C master buffer size is illegal!")},
    {_ERROR_COMM_I2C_MASTER_SUBADDR_NOT_SUPPORT, _T("I2C master is not support the sub address type!")},
    {_ERROR_COMM_DLLFUNCTION_EXPORT, _T("Comm dll function export fail!")},
    {_ERROR_COMM_UNSUPPORT_COMM_TYPE, _T("Comm Type Not Support!")},
    {_ERROR_COMM_RW_REG_PAGE_LEN, _T("Register Page Length Error!")},
    {_ERROR_COMM_RW_REG_CHECKSUM, _T("Register Checksum Error!")},
    {_ERROR_COMM_RW_REG_COMMAND, _T("Register Command Error!")},
    {_ERROR_COMM_I2C_SEGMENT_NOT_SUPPORT, _T("Not support i2c segment access!")},
    {_ERROR_COMM_NOT_SUPPORT, _T("Function not support !")},

    {_ERROR_PLUGIN_EDPISP_ENTERNISP, _T("Enter isp failed!")},
    {_ERROR_PLUGIN_EDPISP_OPENFWFILE, _T("FW file open failed!")},
    {_ERROR_PLUGIN_EDPISP_OPENEDIDFILE, _T("EDID file open failed!")},
    {_ERROR_PLUGIN_EDPISP_OPENFILELENGTH, _T("EDID length is invalid!")},
    {_ERROR_PLUGIN_EDPISP_SCALERTYPE, _T("Scaler type is not matched!")},
    {_ERROR_PLUGIN_EDPISP_CHECKEDIDFILE, _T("The EDID file information is not matched!")},
    {_ERROR_PLUGIN_EDPISP_RESETBOOTLOADER, _T("Reset bootloader failed!")},
    {_ERROR_PLUGIN_EDPISP_FIRSTBYTECHECK, _T("1st byte check failed!")},
    {_ERROR_PLUGIN_EDPISP_1STEEPROMCHECK, _T("1st eeprom write failed!")},
    {_ERROR_PLUGIN_EDPISP_2NDEEPROMCHECK, _T("2nd eeprom write failed")},
    {_ERROR_PLUGIN_EDPISP_CHECKI2CSTATUS, _T("I2C master status check failed!")},
    {_ERROR_PLUGIN_EDPISP_USERSTOP, _T("User stop!")},
    {_ERROR_PLUGIN_EDPISP_IICCMDINCOMPLETE, _T("I2C master command not complete!")},

    {_ERROR_PLUGIN_CTRLREG_COMMON_PORT, _T("Scaler port information error!")},
    {_ERROR_PLUGIN_CTRLREG_COMMON_PAGE, _T("Scaler page information error!")},
    {_ERROR_PLUGIN_CTRLREG_PAGESELECTNOTFIND, _T("Page select register is not found!")},
    {_ERROR_PLUGIN_CTRLREG_PAGEDATANOTFIND, _T("Page data register is not found!")},
    {_ERROR_PLUGIN_CTRLREG_UNSUPPORT_PORTINPORT, _T("Port in port is not supported!")},
    {_ERROR_PLUGIN_CTRLREG_UNSUPPORT_PAGEINPAGE, _T("Page in page is not supported!")},
    {_ERROR_PLUGIN_CTRLREG_REGNAME, _T("Register name is error!")},
    {_ERROR_PLUGIN_CTRLREG_WRITEREG, _T("Register can not be written!")},
    {_ERROR_PLUGIN_CTRLREG_USERSTOP, _T("User stop!")},
    {_ERROR_PLUGIN_CTRLREG_UNPORT, _T("Unknown error!")},
    {_ERROR_PLUGIN_CTRLREG_SCALERTYPE, _T("Unused error!")},
    {_ERROR_PLUGIN_CTRLREG_READ_PORT_FAIL, _T("Read port fail!")},
    {_ERROR_PLUGIN_CTRLREG_PROCESS_QUIT, _T("User cancel!")},
    {_ERROR_PLUGIN_CTRLREG_FIND_NO_MCU_PAGE, _T("Find no MCU page!")},
    {_ERROR_PLUGIN_CTRLREG_ADDR_OUT_OF_RANGE, _T("Out of port range!")},
    {_ERROR_PLUGIN_CTRLREG_INIT_EXCEL_FAIL, _T("Init excel fail!")},
    {_ERROR_PLUGIN_CTRLREG_UFP_CAN_NOT_READ_WRITE, _T("UFP Register Can't Read/Write!")},
    {_ERROR_PLUGIN_CTRLREG_DFP_CAN_NOT_READ_WRITE, _T("DFP Register Can't Read/Write!")},

    {_ERROR_PLUGIN_MCU_ENTERISP, _T("Enter isp failed!")},
    {_ERROR_PLUGIN_MCU_PARAMETER, _T("Invalid Parameter!")},
    {_ERROR_PLUGIN_MCU_OPENFILE, _T("Open file failed!")},
    {_ERROR_PLUGIN_MCU_USERSTOP, _T("User Stop!")},
    {_ERROR_PLUGIN_MCU_DEBUG_MODE_ERROR, _T("Can't Read MCU Through FW when Access Scaler Under ISP Mode!")},
    {_ERROR_PLUGIN_MCU_SELECT_FILE, _T("Select File Fail!")},
    {_ERROR_PLUGIN_MCU_REGISTER_WRTIE, _T("Register can't be written!")},

    {_ERROR_PLUGIN_EFUSE_OPENFILE, _T("Open file failed!")},
    {_ERROR_PLUGIN_EFUSE_FILETYPE, _T("File Type is wrong!")},
    {_ERROR_PLUGIN_EFUSE_LOCKEFUSE, _T("Lock Efuse failed!")},
    {_ERROR_PLUGIN_EFUSE_ISPTIMES, _T("EFuse can not ISP!")},
    {_ERROR_PLUGIN_EFUSE_ISPBIT, _T("Can't ISP Efuse bit from 1 to 0!")},
    {_ERROR_PLUGIN_EFUSE_PROGRAMBIT, _T("Program Efuse faied!")},
    {_ERROR_PLUGIN_EFUSE_UNLOCKEFUSE, _T("Unlock Efuse failed!")},
    {_ERROR_PLUGIN_EFUSE_CHECKSUM, _T("Checksum check failed!")},
    {_ERROR_PLUGIN_EFUSE_DATAINVALID, _T("Invalid Data!")},
    {_ERROR_PLUGIN_EFUSE_SCALERTYPE, _T("Invalid ScalerType!")},
    {_ERROR_PLUGIN_EFUSE_ENTERISP, _T("Enter isp failed!")},
    {_ERROR_PLUGIN_EFUSE_USERCANCEL, _T("User Cancel!")},
    {_ERROR_PLUGIN_EFUSE_ISPDATACHECK, _T("ISP data check failed!")},
    {_ERROR_PLUGIN_EFUSE_ISPNOTNEED, _T("Don't need ISP!")},
    {_ERROR_PLUGIN_EFUSE_COMPARE, _T("Compare Efuse Failed!")},
    {_ERROR_PLUGIN_EFUSE_READFAIL, _T("Efuse Read Failed!")},
    {_ERROR_PLUGIN_EFUSE_BIST_DO_NOTHING, _T("Efuse BIST Do Nothing!")},
    {_ERROR_PLUGIN_EFUSE_FACTORY_PART_ZERO, _T("Efuse Factory Part Zero!")},
    {_ERROR_PLUGIN_EFUSE_READ_MAPPING, _T("Efuse Read Failed!")},
    {_ERROR_PLUGIN_EFUSE_CRC, _T("Efuse CRC Check Failed!")},
    {_ERROR_PLUGIN_EFUSE_NOUSE, _T("Efuse error!")},
    {_ERROR_PLUGIN_EFUSE_TYPE_ERROR, _T("Efuse ISP Type Error!")},
    {_ERROR_PLUGIN_EFUSE_VGADET_NO_APPLY, _T("Has No VGA Detect Correction!")},
    {_ERROR_PLUGIN_EFUSE_READ_UNFINISH, _T("Efuse Read Unfinish!")},
    {_ERROR_PLUGIN_EFUSE_FILE_LEN, _T("File length bigger than data length!")},

    {_ERROR_PLUGIN_DPSTATUS_SCALERTYPE, _T("Invalid ScalerType!")},

    {_ERROR_DEVICE_OPTION_INDIRECT_NOT_SUPPORT_SEGMENT, _T("System EEPROM not support i2c segment command!")},

    {_ERROR_PLUGIN_AUXCONFIG_SCALERTYPE, _T("Invalid ScalerType!")},
    {_ERROR_PLUGIN_AUXCONFIG_COMMACCESS, _T("Get communication Access Type failed!")},
    {_ERROR_PLUGIN_AUXCONFIG_ENTERISP, _T("Enter isp failed!")},
    {_ERROR_PLUGIN_AUXCONFIG_EXITISP, _T("Exit isp failed!")},
    {_ERROR_PLUGIN_AUXCONFIG_ENABLE, _T("Enable Aux Configure failed!")},
    {_ERROR_PLUGIN_AUXCONFIG_SETI2CSLAVEADDR, _T("Set IIC Slave address FAILED!")},
    {_ERROR_PLUGIN_AUXCONFIG_OPENFILE, _T("Open FILE failed!")},
    {_ERROR_PLUGIN_AUXCONFIG_FILETYPE, _T("File Type is wrong!")},
    {_ERROR_PLUGIN_AUXCONFIG_LIGHTUP, _T("Eanble LVDS Setting Fail!")},

    {_ERROR_COMM_SMBUS_INIT_FAIL, _T("Smbus Init fail!")},
    {_ERROR_COMM_SMBUS_PARAMETER, _T("Invalid Parameter!")},
    {_ERROR_COMM_SMBUS_READ_FAIL, _T("Smbus Read fail!")},
    {_ERROR_COMM_SMBUS_WRITE_FAIL, _T("Smbus Write fail!")},
    {_ERROR_COMM_SMBUS_NOT_SUPPORT, _T("Not Support!")},
    {_ERROR_COMM_SMBUS_I2C_PAGELENGTH_UNSUPPORT, _T("Pagelength UnSupport!")},
    {_ERROR_COMM_ECSMBUS_HOST_WRITE, _T("EC Smbus Host Write Fail!")},
    {_ERROR_COMM_ECSMBUS_HOST_READ, _T("EC Smbus Host Write Read!")},
    {_ERROR_COMM_ECSMBUS_IBF_FULL, _T("EC Smbus Input Buffer Is Full!")},
    {_ERROR_COMM_ECSMBUS_OBF_EMPTY, _T("EC Smbus Output Buffer Is Empty!")},
    {_ERROR_COMM_SMBUS_BLOCK_READ_DATA_LENGTH_ERROR, _T("Block Read Data Length Error!")},
    {_ERROR_COMM_SMBUS_AUTO_DETECT_FAIL, _T("Smbus Auto Detect Fail!")},
    {_ERROR_COMM_SMBUS_LINUX_SET_SLAVE_ADDR, _T("Linux set smbus slave address fail!")},
    {_ERROR_COMM_SMBUS_LINUX_READ_BYTE_FAIL, _T("Smbus read byte fail!")},
    {_ERROR_COMM_SMBUS_LINUX_WRITE_BYTE_FAIL, _T("Smbus write byte fail!")},
    {_ERROR_COMM_SMBUS_LINUX_READ_BYTE_DATA_FAIL, _T("Smbus read byte data fail!")},
    {_ERROR_COMM_SMBUS_LINUX_WRITE_BYTE_DATA_FAIL, _T("Smbus write byte data fail!")},
    {_ERROR_COMM_SMBUS_LINUX_READ_WORD_DATA_FAIL, _T("Smbus read word data fail!")},
    {_ERROR_COMM_SMBUS_LINUX_WRITE_WORD_DATA_FAIL, _T("Smbus write word data fail!")},
    {_ERROR_COMM_SMBUS_LINUX_READ_BLOCK_DATA_FAIL, _T("Smbus read block data fail!")},
    {_ERROR_COMM_SMBUS_LINUX_WRITE_BLOCK_DATA_FAIL, _T("Smbus write block data fail!")},

    {_ERROR_COMM_AUX_INIT_FAIL, _T("Aux Init fail!")},
    {_ERROR_COMM_AUX_PARAMETER, _T("Invalid Parameter!")},
    {_ERROR_COMM_AUX_READ_FAIL, _T("Aux Read fail!")},
    {_ERROR_COMM_AUX_WRITE_FAIL, _T("Aux Write fail!")},
    {_ERROR_COMM_AUX_NOT_SUPPORT, _T("Not Support!")},
    {_ERROR_COMM_AUX_NATIVE_WRITE_FAIL, _T("Aux Native Write fail!")},
    {_ERROR_COMM_AUX_NATIVE_READ_FAIL, _T("Aux Native Read fail!")},
    {_ERROR_COMM_AUX_I2C_PAGELENGTH, _T("Pagelength UnSupport!")},
    {_ERROR_COMM_AUX_NATIVE_PAGELENGTH, _T("Native Pagelength UnSupport!")},

    {_ERROR_COMM_REALTEKUSB_FAIL_SELECTDEVICE, _T("SelectUsb Device fail!")},
    {_ERROR_COMM_REALTEKUSB_NOT_SUPPORT, _T("Not Support!")},
    {_ERROR_COMM_REALTEKUSB_INVALID_PARAMETER, _T("Invalid Parameter!")},
    {_ERROR_COMM_REALTEKUSB_WRITEFILE_FAIL, _T("Write fail!")},
    {_ERROR_COMM_REALTEKUSB_WRITEFILE_LENGTH, _T("Write length error!")},
    {_ERROR_COMM_REALTEKUSB_READFILE_FAIL, _T("Read fail!")},
    {_ERROR_COMM_REALTEKUSB_READFILE_LENGTH, _T("Read length error!")},
    {_ERROR_COMM_REALTEKUSB_RECEIVEDATA_CHECKSUM, _T("Received data checksum error!")},
    {_ERROR_COMM_REALTEKUSB_I2C_PAGELENGTH_UNSUPPORT, _T("Not support get length!")},
    {_ERROR_COMM_REALTEKUSB_I2C_READCOUNT, _T("Read count error!")},
    {_ERROR_COMM_REALTEKUSB_I2C_SPEED_UNSUPPORT, _T("Speed not support!")},
    {_ERROR_COMM_REALTEKUSB_RESET_FW, _T("Reset FW error!")},
    {_ERROR_COMM_REALTEKUSB_DRIVER_INSTALL, _T("Install driver error!")},
    {_ERROR_COMM_REALTEKUSB_I2C_START, _T("I2C start error!")},
    {_ERROR_COMM_REALTEKUSB_I2C_NOACK, _T("I2C no ack!")},
    {_ERROR_COMM_REALTEKUSB_I2C_POLLING, _T("I2C polling error!")},
    {_ERROR_COMM_REALTEKUSB_I2C_INVALID_PARAMS, _T("Invaleid I2C params!")},
    {_ERROR_COMM_REALTEKUSB_I2C_CHECK_HIGHSCL, _T("Check I2C SCL error!")},
    {_ERROR_COMM_REALTEKUSB_I2C_CHECKSUM, _T("Check I2C Data CheckSum error!")},
    {_ERROR_COMM_REALTEKUSB_GETDEVICEPATH_FAIL, _T("Get Device Path Fail!")},
    {_ERROR_COMM_REALTEKUSB_DEVICEPATH_ILLEGAL, _T("Device Path Illegal!")},

    {_ERROR_PLUGIN_DPCD_USERSTOP, _T("User stop!")},
    {_ERROR_PLUGIN_DPCD_FILE_LENGTH, _T("File length is not match with scaler!")},
    {_ERROR_PLUGIN_DPCD_SCALERTYPE, _T("Scaler type is not matched!")},
    {_ERROR_PLUGIN_DPCD_AUXWRITE, _T("Aux communication can not write the whole DPCD Table!")},
    {_ERROR_PLUGIN_DPCD_LOAD_FILE, _T("DPCD Laod File Failed!")},
    {_ERROR_PLUGIN_DPCD_ILLEGAL_FILE, _T("DPCD File Illegal!")},
    {_ERROR_PLUGIN_DPCD_WRITE_REG_FAIL, _T("DPCD can not write the register!")},

    {_ERROR_PLUGIN_EDID_USERSTOP, _T("User stop!")},
    {_ERROR_PLUGIN_EDID_WRITECHECK, _T("Data check failed!")},
    {_ERROR_PLUGIN_EDID_IICCMDINCOMPLETE, _T("I2C master command not complete!")},
    {_ERROR_PLUGIN_EDID_ENABLEDDCRAM, _T("Enable DDC Ram Failed!")},
    {_ERROR_PLUGIN_EDID_DISABLEDDCRAM, _T("Disable DDC Ram Failed!")},
    {_ERROR_PLUGIN_EDID_ILLEGAL_FILE, _T("EDID File Illegal!")},
    {_ERROR_PLUGIN_EDID_AUX_UNSUPPORT_DERICT_MODE, _T("Aux not support derict mode read edid!")},
    {_ERROR_PLUGIN_EDID_INTERNAL_NOT_WRITE, _T("Internal EDID should not be write!")},
    {_ERROR_PLUGIN_EDID_ILLEGAL_HEADER, _T("Illegal EDID header!")},
    {_ERROR_PLUGIN_EDID_BASE_CHECKSUM_ERROR, _T("Base block edid check sum error!")},
    {_ERROR_PLUGIN_EDID_EXTENSION_CHECKSUM_ERROR, _T("Extension block edid check sum error!")},
    {_ERROR_PLUGIN_EDID_CEA_DETAILED_DATA_ILLEGAL, _T("CEA extension detailed timing data error!")},
    {_ERROR_PLUGIN_EDID_ACCESS_METHOD_ILLEGAL, _T("Access method error!")},

    {_ERROR_MP_EFUSE_LOAD_CONFIGFILE, _T("Load configure file fail!")},
    {_ERROR_MP_EFUSE_ILLEGAL_SCALERTYPE, _T("Illegal scaler type define in config file!")},
    {_ERROR_MP_EFUSE_ILLEGAL_FILETYPE, _T("Illegal file type define in config file!")},
    {_ERROR_MP_EFUSE_NONE_FILE, _T("None file define in config file!")},
    {_ERROR_MP_EFUSE_ILLEGAL_PROGRAMMETHOD, _T("Illegal program method define in config file!")},
    {_ERROR_MP_EFUSE_ILLEGAL_ISPOPTION, _T("Illegal isp option define in config file!")},

    // For ISPTool PlugIn
    {_ERROR_PLUGIN_ISP_OPEN_FILE_FAIL, _T("Open file fail!")},
    {_ERROR_PLUGIN_ISP_CANCEL, _T("Isp cancel!")},
    {_ERROR_PLUGIN_ISP_LOADANSI_FAIL, _T("Load ansi file fail!")},
    {_ERROR_PLUGIN_ISP_FLASH_MISMATCH_USE_DEFAULT_VALUE, _T("Flash mismatch, use default value!")},
    {_ERROR_PLUGIN_ISP_WRITE_FIRST_PAGE_ERROR, _T("Write code to first page fail!")},
    {_ERROR_PLUGIN_ISP_FLASH_FILE_ILLEAGL, _T("FalshSet.dat illegal!")},
    {_ERROR_PLUGIN_ISP_BANK_NO_ENOUGH, _T("The maximum index of checked bank in the UI is more than the total count of flash bank! Quit.")},
    {_ERROR_PLUGIN_ISP_PREPARE_DATA_FAIL, _T("Prepare data fail!")},
    {_ERROR_PLUGIN_ISP_AUTO_SEARCH_MORETHAN_ONE_FILE_MEET, _T("More than 1 file meets. Stop isp.")},
    {_ERROR_PLUGIN_ISP_PARA_ILLEGAL, _T("Para illegal!")},
    {_ERROR_PLUGIN_ISP_SCALER_IC_MISMATCH, _T("Scaler mismatch!")},
    {_ERROR_PLUGIN_ISP_UNDEFINE_PNL_MODE, _T("Undefined PNL mode!")},
    {_ERROR_PLUGIN_ISP_ILLEGAL_HP_AIO_BIG_BIN_FILE, _T("Illegal big bin file!")},
    {_ERROR_PLUGIN_ISP_SCALER_ID_MISMATCH, _T("Scaler ID mismatch in FW flash partition!")},
    {_ERROR_PLUGIN_ISP_PROJECT_NAME_MISMATCH, _T("Project name mismatch in FW flash partition!")},
    {_ERROR_PLUGIN_ISP_FLASH_MISMATCH_6420, _T("Get flash type is not W25Q05CLWI!")},
    {_ERROR_PLUGIN_ISP_SCALER_MISMATCH_6420, _T("Scaler type mismatch!")},
    {_ERROR_PLUGIN_ISP_AIO_SETTING_ILLEGAL, _T("AIOSetting.ini file is illegal!")},
    {_ERROR_PLUGIN_ISP_NOT_FIND_AIO_SETTING_FILE, _T("Not find AIOSetting.ini file!")},
    {_ERROR_PLUGIN_ISP_NOT_FIND_AIO_SCALER_INFO, _T("Not find scaler info in AIOSetting.ini file!")},
    {_ERROR_PLUGIN_ISP_NOT_FIND_AIO_PANEL_INFO, _T("Not find panel info in AIOSetting.ini file!")},
    {_ERROR_PLUGIN_ISP_NOT_FIND_AIO_FW_FILE, _T("Not find AIO fw file!")},
    {_ERROR_PLUGIN_ISP_BUTTON_DISABLE, _T("FW file's path may change, check again!")},
    {_ERROR_PLUGIN_ISP_DDCCI_CHECK_FAIL, _T("DDCCI check fail!")},
    {_ERROR_PLUGIN_ISP_ENABLE_ISP_CHANNEL_FAIL, _T("Enable isp channel fail!")},
    {_ERROR_PLUGIN_ISP_CHECK_MACHINE_ID_FAIL, _T("Enable Machine ID fail!")},
    {_ERROR_PLUGIN_ISP_DEBUG_MODE_ERROR, _T("Not support isp mode!")},
    {_ERROR_PLUGIN_ISP_GET_BEING_UPDATE_FW_VER_FAIL, _T("Get being update fw version fail!")},
    {_ERROR_PLUGIN_ISP_GET_CURRENT_FW_VER_FAIL, _T("Get current fw version fail!")},
    {_ERROR_PLUGIN_ISP_VER_COMPARE_FAIL, _T("Not support isp because version compare fail!")},
    {_ERROR_PLUGIN_ISP_SWITCH_TO_BOOT_CODE, _T("Switch to rom code  fail!")},
    {_ERROR_PLUGIN_ISP_QHD_SIGN_FAIL, _T("Signature fail!")},
    {_ERROR_PLUGIN_ISP_QHD_POLLING_SIGN_FINISH_FAIL, _T("Polling signature finish fail!")},
    {_ERROR_PLUGIN_ISP_QHD_POLLING_SLAVE_FAIL, _T("Polling DDCCI slave address fail!")},
    {_ERROR_PLUGIN_ISP_QHD_GET_SIGN_STATUS_FAIL, _T("Get signature status fail!")},
    {_ERROR_PLUGIN_ISP_COPY_BANK_OPEN_FW_FAIL, _T("Open bin file fail,Copy Bank to check version!")},
    {_ERROR_PLUGIN_ISP_COPY_BANK_NOT_NEED_ISP, _T("The bin file should not be program for version!")},
    {_ERROR_PLUGIN_ISP_COPY_BANK_UPDATE_COMBINE_VER_FAIL, _T("Update combine bin file version fail!")},
    {_ERROR_PLUGIN_ISP_COPY_BANK_POLLING_FW_FINISH_FAIL, _T("Polling fw idle time out!")},
    {_ERROR_PLUGIN_ISP_COPY_BANK_EQUAL_INSTALLED_VERSION, _T("FW version equal installed version!")},
    {_ERROR_PLUGIN_ISP_COPY_BANK_LESS_THAN_INSTALLED_VERSION, _T("FW version less than installed version!")},
    {_ERROR_PLUGIN_ISP_FW_VERSION_NOT_NEW, _T("Fw Version Not New!")},
    {_ERROR_PLUGIN_ISP_FW_VERSION_NEW, _T("Fw Version New!")},
	{_ERROR_PLUGIN_ISP_CMD_STRING_TO_BYTE, _T("CMD String To Byte!") },
	{_ERROR_PLUGIN_ISP_SPECIFIED_FLASH_NAME_EMPTY, _T("Specified Flash Name Empty!") },
	{_ERROR_PLUGIN_ISP_NOT_FIND_SPECIFIED_FLASH_INFO, _T("Not Find Specified Flash Info!" }),
	{_ERROR_PLUGIN_ISP_WRITE_FLASH_SR_OPCODE, _T("Write Flash SR OPcode!") },
	{_ERROR_PLUGIN_ISP_FLASH_MAP_EMPTY, _T("Flash Map Empty!") },
	{ _ERROR_PLUGIN_ISP_FW_MAP_EMPTY, _T("FW Map Empty!") },
	{ _ERROR_PLUGIN_ISP_LOAD_ONE_BANK_FW, _T("Load FW Bank !") },
	{ _ERROR_PLUGIN_ISP_ONLY_CHIP_ERASE_HAVE_RESERVE_SETTING, _T("Only Chip Erase Have Reserve Setting!") },
	{ _ERROR_PLUGIN_ISP_DEBUG_MODE_SWTICH_DDCCI_MODE_FAIL, _T("Debug Mode Switch DDCCI Mode Fail!") },
	{ _ERROR_PLUGIN_ISP_FACTORY_MODE_SWTICH_DDCCI_MODE_FAIL, _T("Factory Mode Switch DDCCI Mode! Fail") },
	{ _ERROR_PLUGIN_ISP_DDCCI_COMMUNICATION_HANDSHAKE_FAIL, _T("DDCCI Communication HandShake Fail!") },
	{ _ERROR_PLUGIN_ISP_POLLING_FW_SIGNATURE_FINISH_FAIL, _T("Polling FW Signature Finish Fail!") },
	{ _ERROR_PLUGIN_ISP_TARGET_FLASH_BANK_DUPLICATION, _T("Target Flash Bank Duplication!") },
	{ _ERROR_PLUGIN_ISP_ALL_SLAVE_ADDR_NACK, _T("All Slave Addr Nack!") },
	{ _ERROR_PLUGIN_ISP_DO_ISP_NO_INITIAL, _T("Do Isp No Initial!") },
	{ _ERROR_PLUGIN_ISP_PROGRESS_SET_RANGE, _T("Isp Progress Set Range!")},

    //for eeprom plugIn
    {_ERROR_PLUGIN_EDPEEPROM_SET_DEFAULT_VALUE_FAIL, _T("Set Default Value Failed!")},
    {_ERROR_PLUGIN_EDPEEPROM_LOAD_FILE, _T("Laod File Failed!")},
    {_ERROR_PLUGIN_EDPEEPROM_ILLEGAL_FILE, _T("File Illegal!")},
    {_ERROR_PLUGIN_EDPEEPROM_USERSTOP, _T("User Stop!")},   

    {_ERROR_PLUGIN_ISP_CRC_DIFFERENT_ERASE_FAIL, _T("CRC different. Erase fail!")},
    {_ERROR_PLUGIN_ISP_CRC_DIFFERENT_ISP_FAIL, _T("CRC different. Isp fail!")},
    {_ERROR_PLUGIN_ISP_NO_NEED_CONTINUE, _T("The bank's data is same with flash's, not need isp!")},
    {_ERROR_PLUGIN_ISP_BANK0_NO_ENOUGH_TO_STORE_SETTING, _T("Bank0 has no enough space to store setting data!")},
    {_ERROR_PLUGIN_ISP_SMBUS_SET_BLOCK_TYPE_FAIL, _T("Set smbus block type fail!")},
    {_ERROR_PLUGIN_ISP_SCALER_NOT_SUPPORT, _T("Scaler is not support or detect scaler fail!")},
    {_ERROR_PLUGIN_ISP_FAIL, _T("Isp fail!")},

    //for isp edid plunin 
    {_ERROR_PLUGIN_ISP_EDID_ENTERNISP, _T("Entern Isp mode fail!")},
    {_ERROR_PLUGIN_ISP_EDID_OPENEDIDFILE, _T("Open EDID file fail!")},
    {_ERROR_PLUGIN_ISP_EDID_ERRORFILELENTH, _T("File length Error!")},
    {_ERROR_PLUGIN_ISP_EDID_OPENFLASHDAT, _T("Open falsh data file!")},
    {_ERROR_PLUGIN_ISP_EDID_CRC_CHECK_FAIL, _T("CRC check fail!")},
    {_ERROR_PLUGIN_ISP_EDID_FLASHSIZE_ERROR, _T("Flashsize Error!")},

    // for grid
    {_ERROR_GRID_EMPTY_VALUE, _T("Empty Value!")},
    {_ERROR_GRID_ILLEGAL_VALUE, _T("Illegal Value!")},

    // for mp ISP
    {_ERROR_PLUGIN_MP_ISP_CONFIGFILE, _T("Config File Error!")},
    {_ERROR_PLUGIN_MP_ISP_SCALERTYPE, _T("Scaler Type Error!")},
    {_ERROR_PLUGIN_MP_ISP_PROGRAMMETHOD, _T("Program Methond Error!")},
    {_ERROR_PLUGIN_MP_ISP_PROGRAMFW, _T("Program FW Error!")},
    {_ERROR_PLUGIN_MP_ISP_PROGRAMEDID, _T("Program EDID Error!")},
    {_ERROR_PLUGIN_MP_ISP_2NDEEPROMADDR, _T("Second Eeprom Address Error!")},
    {_ERROR_PLUGIN_MP_ISP_PROGRAMCOUNT, _T("Program Count Error!")},
    {_ERROR_PLUGIN_MP_ISP_1STROMSPEED, _T("First Eeprom Speed Error!")},
    {_ERROR_PLUGIN_MP_ISP_2NDROMSPEED, _T("Second Eeprom Speed Error!")},
    {_ERROR_PLUGIN_MP_ISP_DELAYTIME, _T("Delay Time Error!")},

    {_ERROR_PLUGIN_MP_FW_VERSION_CONFIGFILE, _T("Config File Error!")},
    {_ERROR_PLUGIN_MP_FW_VERSION_SCALERTYPE, _T("Scaler Type Error!")},
    {_ERROR_PLUGIN_MP_FW_VERSION_PROGRAMMETHOD, _T("Program Method Error!")},
    {_ERROR_PLUGIN_MP_FW_VERSION_DELAYTIME, _T("Delay Time Error!")},
    {_ERROR_PLUGIN_MP_FW_VERSION_FWVERSION_FORMAT, _T("FW Version Foramt Error!")},
    {_ERROR_PLUGIN_MP_FW_VERSION_FW_COMPARE_FAIL, _T("FW Compare Failed!")},
    //for debugMessage
    {_ERROR_PLUGIN_DEBUG_MESSAGE_CHECKSUM_ERROR, _T("Debug Message Checksum Error!")},
    //for RTD Tool 
    {_ERROR_RTDTOOL_FIND_NO_SCALER_INFO, _T("No Scaler Info!")},
    {_ERROR_RTDTOOL_MORE_THEN_ONE_SCALER_HAVE_SAME_ID, _T("More then one scaler has same ID. Ignore it!")},
    {_ERROR_RTDTOOL_MORE_THEN_ONE_SCALER_HAVE_SAME_NAME, _T("More then one scaler has same name. Ignore it!")},
    {_ERROR_RTDTOOL_CAN_NOT_WRITE_TO_PROGRAM_FILES, _T("Can't write to program files!")},
    {_ERROR_RTDTOOL_CURRENT_IC_FORBIDDEN, _T("Current IC is fobidden!")},
    {_ERROR_RTDTOOL_CURRENT_IC_WARNING, _T("Current IC has warnings!")},
    {_ERROR_RTDTOOL_USER_WANT_RETURN, _T("User click return.")},

    // For flash plugin
    {_ERROR_PLUGIN_FLASH_USER_CANCEL_READING, _T("User cancel it")},

    // GT Plugin
    {_ERROR_PLUGIN_GT_CMD_ERROR, _T("GT cmd is illegal!")},
    {_ERROR_PLUGIN_GT_TXT_NO_CMD, _T("No cmd!")},
    {_ERROR_PLUGIN_GT_BYTES_TO_WRITE_NO_ENOUGH, _T("Values to write is not enough!")},
    {_ERROR_PLUGIN_GT_IGNORE_CMD, _T("Ignore this Cmd!")},
    {_ERROR_PLUGIN_GT_READ_CMD_LOST_CHECK_VALUE, _T("Warnings: READ(addr, checkValue) lost checkValue info!")},
    {_ERROR_PLUGIN_GT_OUT_OF_BUFFER, _T("Out of buffer!")},
    {_ERROR_PLUGIN_GT_MORE_THAN_ONE_CMD, _T("More than one cmd in the same line!")},
    {_ERROR_PLUGIN_GT_VALUE_MORE_BYTE, _T("GT is illegal, register should be one byte!")},

    // Ram Plugin
    {_ERROR_PLUGIN_RAM_ERROR_VALUE, _T("Error value")},
    {_ERROR_PLUGIN_RAM_MODIFY_REG_FAIL, _T("Modify reg fail!")},
    {_ERROR_PLUGIN_RAM_READ_CANCEL, _T("User cancel it")},

    {_ERROR_PINSHARVERIFY_ERROR_COMPARE_VALUE, _T("Pin Value Compare fail!")},
    {_ERROR_PINSHARVERIFY_ERROR_CREATE_REPORT_FILE, _T("Create Report File Fail!")},
    {_ERROR_PINSHARVERIFY_ERROR_SARADC_INDEX_EMPTY, _T("ADC index empty, Select first!")},
    {_ERROR_PINSHARVERIFY_ERROR_SARADC_CLK_DIV_ILLEGAL, _T("ADC clk Divider is illegal!")},
    {_ERROR_PINSHARVERIFY_ERROR_NO_DDC_ENOUGH_INFO, _T("Find no DDC reg info!")},
    {_ERROR_PINSHARVERIFY_ERROR_WRITE_READ_DIFFERENT,_T("Write reg fail!")},
    {_ERROR_PINSHARVERIFY_ERROR_NO_I2C_ENOUGH_INFO, _T("I2C no enough info!")},
    {_ERROR_PINSHARVERIFY_ERROR_NO_ADC_ENOUGH_INFO, _T("Find no ADC info!")},

    {_ERROR_PINSHARVERIFY_ERROR_NO_INTIRQ_ENOUGH_INFO, _T("Find no INT&IRQ reg info!")},
    {_ERROR_PINSHARVERIFY_ERROR_NO_TIMER_ENOUGH_INFO, _T("Find no Timer reg info!")},
    {_ERROR_PINSHARVERIFY_ERROR_NO_VIHVIL_ENOUGH_INFO, _T("Find no VIHVIL reg info!")},
    {_ERROR_PINSHARVERIFY_ERROR_NO_TESTPIN_ENOUGH_INFO, _T("Find no TestPin reg info!")},
    {_ERROR_PINSHARVERIFY_ERROR_NO_CLKO_ENOUGH_INFO, _T("Find no CLKO reg info!")},
    {_ERROR_PINSHARVERIFY_ERROR_NO_SLEWCTRL_ENOUGH_INFO, _T("Find no slew control reg info!")},
    {_ERROR_PINSHARVERIFY_ERROR_ADC_TIME_OUT, _T("Adc conversion time out!")},
    {_ERROR_PINSHARVERIFY_IIC_TRANSCATION_ERROR, _T("IIC transcation fail!")},
    {_ERROR_PINSHARVERIFY_IIC_TIME_OUT, _T("IIC time out")},
    {_ERROR_SCOPE_GET_DUTY_FAIL, _T("Scope Get Duty Fail!")},
    {_ERROR_SCOPE_GET_FREQ_FAIL, _T("Scope Get Freq Fail!")},
    {_ERROR_SCOPE_SET_CHANNEL_DISPLAY_FAIL, _T("Channel display fail!")},
    {_ERROR_INSTRUMENT_INIT_SCOPE_FAIL, _T("Init scope fail!")},
    {_ERROR_INSTRUMENT_INIT_POWERSUPPLY_FAIL, _T("Init powersupply fail!")},
    {_ERROR_INSTRUMENT_INIT_INSTRUMENT_FAIL, _T("Init instrument fail!")},
    {_ERROR_POWERSUPPLY_SET_VOLTAGE_FAIL, _T("Power supply set voltage fail!")},
    {_ERROR_PLUGIN_USBPHY_TIMEOUT, _T("Polling register time out!")},
    {_ERROR_PINSHARVERIFY_IIC_EEPROM_TEST_FAIL, _T("EEPROM test fail!")},
    {_ERROR_SCOPE_MEAS_CLEAR_FAIL, _T("Measure clear fail!")},
    {_ERROR_SCOPE_MEAS_FREQ_FAIL, _T("Measure frequency fail!")},
    {_ERROR_SCOPE_MEAS_STAT_MEAN_FAIL, _T("Statics mean fail!")},
    {_ERROR_SCOPE_GET_MEAS_RESULTS_FAIL, _T("Read results fail!")},
    {_ERROR_SCOPE_SET_MEASURE_SOURCE_FAIL, _T("Set measure source fail!")},
    {_ERROR_SCOPE_SET_SWEEP_MODE_FAIL, _T("Set sweep mode fail!")},
    {_ERROR_SCOPE_SET_HORIZONTAL_SCALE_FAIL, _T("Set horizontal scale fail!")},
    {_ERROR_SCOPE_MEAS_VPP_VOLTAGE_FAIL, _T("Get VPP fail!")},
    {_ERROR_SCOPE_MEAS_VRMS_VOLTAGE_FAIL, _T("Get Vrms fail!")},
    {_ERROR_SCOPE_SET_CHAN_OFFSET_FAIL, _T("Set channel offset fail!")},
    {_ERROR_SCOPE_SET_CHAN_SCALE_FAIL, _T("Set channel scale fail!")},
    {_ERROR_SCOPE_SET_TRIGGER_LEVEL_FAIL, _T("Set channel trigger level fail!")},
    {_ERROR_SCOPE_SET_FUNC_VCM_FAIL, _T("Set function common mode fail!")},
    {_ERROR_SCOPE_SET_HISTOGRAM_FAIL, _T("Set histogram fail!")},
    {_ERROR_SCOPE_ENABLE_CGRADE_FAIL, _T("Enable color grade fail!")},
    {_ERROR_SCOPE_MEAS_HIST_MEAN_FAIL, _T("Measure histogram mean value fail!")},
    {_ERROR_SCOPE_MEAS_HIST_PP_FAIL, _T("Measure histogram Vpp value fail!")},
    {_ERROR_SCOPE_MEAS_HIST_STDDEV_FAIL, _T("Measure histogram std-dev value fail!")},
    {_ERROR_SCOPE_MEAS_HIST_MIN_FAIL, _T("Measure histogram min value fail!")},
    {_ERROR_SCOPE_MEAS_HIST_MAX_FAIL, _T("Measure histogram max value fail!")},
    {_ERROR_SCOPE_RUN_FAIL, _T("Scope run fail!")},
    {_ERROR_SCOPE_STOP_FAIL, _T("Scope stop fail!")},
    {_ERROR_SCOPE_RESET_FAIL, _T("Scope reset fail!")},
    {_ERROR_SCOPE_CLEAR_DISPLAY_FAIL, _T("Scope clear display fail!")},
    {_ERROR_SCOPE_SET_TRIGGER_LEV_FIFTY_FAIL, _T("Scope set trigger level fifty fail!")},
    {_ERROR_SCOPE_GET_TRIGGER_LEV_FAIL, _T("Scope get trigger level fail!")},
    {_ERROR_SCOPE_GET_TIME_POS_FAIL, _T("Scope get time position fail!")},
    {_ERROR_SCOPE_SET_DISPLAY_GRATICULE_FAIL, _T("Scope set display graticule fail!")},
    {_ERROR_SCOPE_SET_TIMEBASE_RANGE_FAIL, _T("Scope set timebase range fail!")},
    {_ERROR_SCOPE_MEAS_HIST_HITS_FAIL, _T("Measure histogram hits value fail!")},
    {_ERROR_SCOPE_MEAS_EDGE_TO_EDGE_FAIL, _T("Scope measure edge to edge time fail!")},
    {_ERROR_SCOPE_SET_TRIGGER_SOURCE_FAIL, _T("Scope set trigger source fail!")},
    {_ERROR_SCOPE_SHOW_CHANNEL_FAIL, _T("Scope show channel fail!")},
    {_ERROR_SCOPE_MEAS_PERIOD_PERIOD_FAIL, _T("Scope measure period-period fail!")},
    {_ERROR_SCOPE_MEAS_NPERIOD_FAIL, _T("Scope measure long term period fail!")},
    {_ERROR_SCOPE_MEAS_PERIOD_FAIL, _T("Scope measure period fail!")},
    {_ERROR_SCOPE_MEAS_STAT_ALL_FAIL, _T("Scope measure statistics all value fail!")},
    {_ERROR_SCOPE_MEAS_STAT_MIN_FAIL, _T("Scope measure statistics min value fail!")},
    {_ERROR_SCOPE_MEAS_STAT_MAX_FAIL, _T("Scope measure statistics max value fail!")},
    {_ERROR_SCOPE_MEAS_STAT_STDDEV_FAIL, _T("Scope measure statistics stddev value fail!")},
    {_ERROR_SCOPE_MEAS_STAT_MEAS_FAIL, _T("Scope measure statistics #of meas value fail!")},
    {_ERROR_SCOPE_EZJIT_SETTING_FAIL, _T("Scope ezjit setting fail!")},

    {_ERROR_PLUGIN_USBMEMORY_DATA_ERROR, _T("Data Error!")},

    {_ERROR_COMM_FTDIUSB_INIT_FAIL, _T("FTDI Usb Init Fail!")},
    {_ERROR_COMM_FTDIUSB_LOAD_DLL_FAIL, _T("Load Ftd2xx.dll Fail!")},
    {_ERROR_COMM_FTDIUSB_LOAD_FUNC_FAIL, _T("Load Function From Dll Fail!")},
    {_ERROR_COMM_FTDIUSB_SELECTDEVICE_FAIL, _T("Select FTDIUsb Fail!")},
    {_ERROR_COMM_FTDIUSB_SET_MPSSE_MODE_FAIL, _T("Set MPSSE Mode Fail!")},
    {_ERROR_COMM_FTDIUSB_CONFIG_MPSSE_FAIL, _T("Config MPSSE Mode Fail!")},
    {_ERROR_COMM_FTDIUSB_SNED_CMD_FAIL, _T("Send FTDI USB Cmd Fail!")},
    {_ERROR_COMM_FTDIUSB_SNED_BYTE_ERROR, _T("Send Bytes Error!")},
    {_ERROR_COMM_FTDIUSB_ENABLE_LOOPBACK_FAIL, _T("Enable Loopback Fail!")},
    {_ERROR_COMM_FTDIUSB_BAD_COMMAND_DETECTION_FAIL, _T("Test Bad Command Fail!")},
    {_ERROR_COMM_FTDIUSB_INIT_MPSSE_STATE_FAIL, _T("Init MPSSE State Fail!")},
    {_ERROR_COMM_FTDIUSB_SET_CLK_DIVISOR_ERROR, _T("Set Clk Divisor Error!")},
    {_ERROR_COMM_FTDIUSB_INVALID_PARAMETER, _T("Invalid Parameter!")},
    {_ERROR_COMM_FTDIUSB_WAIT_READ_QUEUE_TIMEOUT, _T("Wait Read Queue Timeout!")},
    {_ERROR_COMM_FTDIUSB_GET_QUEUE_STATUS_FAIL, _T("Get Queue Status Fail!")},
    {_ERROR_COMM_FTDIUSB_READ_FAIL, _T("FTDIUsb Read Fail!")},
    {_ERROR_COMM_FTDIUSB_WRITE_FAIL, _T("FTDIUsb Write Fail!")},
    {_ERROR_COMM_FTDIUSB_I2C_PAGELENGTH_UNSUPPORT, _T("Not support get length!")},
    {_ERROR_COMM_FTDIUSB_SPEED_NOT_SUPPORT, _T("Speed Not Support!")},
    {_ERROR_COMM_FTDIUSB_NOT_SUPPORT, _T("FTDI Usb Don't support this Function!")},
    {_ERROR_COMM_FTDIUSB_GET_ACK_FAIL, _T("FTDI Usb Get Ack Fail!")},
    {_ERROR_COMM_FTDIUSB_CHECK_I2C_SCL_FAIL, _T("FTDI Usb Check SCL Fail!")},

    {_ERROR_PLUGIN_OD_OPEN_FILE_FAIL, _T("Open file fail!")},
    {_ERROR_PLUGIN_OD_ILLEGAL_FILE, _T("OD File Illegal!!")},
    {_ERROR_PLUGIN_OD_DATA_LEN_ERROR, _T("OD Data Length Error!!")},

    {_ERROR_PLUGIN_MEASURE_MEAS_ERROR, _T("Measure error!")},
    {_ERROR_INSTRUMENT_INIT_FAIL, _T("Instrument init fail!")},
    {_ERROR_POWER_SUPPLY_NOT_SET_OUTPUT_ON, _T("Powersupply not set output on!")},
    {_ERROR_POWER_SUPPLY_SET_VOLT_TIME_OUT, _T("Set voltage time out!")},
    {_ERROR_POWER_SUPPLY_GET_PORT_SELECTION_FAIL, _T("Powersupply get port fail!")},
    {_ERROR_POWER_SUPPLY_SET_PORT_SELECTION_FAIL, _T("Powersupply set port fail!")},
    {_ERROR_POWER_SUPPLY_GET_OUTPUT_STATE_FAIL, _T("Powersupply get output state fail!")},
    {_ERROR_POWER_SUPPLY_SET_OUTPUT_STATE_FAIL, _T("Powersupply set output state fail!")},
    {_ERROR_POWER_SUPPLY_SET_VOLT_FAIL, _T("Powersupply set voltage fail!")},
    {_ERROR_POWER_SUPPLY_GET_VOLT_FAIL, _T("Powersupply get voltage fail!")},
    {_ERROR_POWER_SUPPLY_MEASURE_VOLT_FAIL, _T("Powersupply measure voltage fail!")},
    {_ERROR_POWER_SUPPLY_SET_RANGE_FAIL, _T("Set power supply range fail!")},
    {_ERROR_POWER_SUPPLY_SET_REMOTE_OR_LOCAL_FAIL, _T("Power supply set remote/local fail!")},
    {_ERROR_POWER_SUPPLY_SET_CURRENT_FAIL, _T("Set power supply current fail!")},
    {_ERROR_SCOPE_MEASURE_AVERAGE_VOLTAGE_FAIL, _T("Scope measure average voltage fail!")},
    {_ERROR_SCOPE_SET_THRESHOLD_VALUE_FAIL, _T("Scope set threshold value fail!")},
    {_ERROR_SCOPE_MEASURE_FALL_TIME_FAIL, _T("Scope measure fall time fail!")},
    {_ERROR_SCOPE_MEASURE_RISE_TIME_FAIL, _T("Scope measure rise time fail!")},
    {_ERROR_SCOPE_QUERY_THRESHOLDS_FAIL, _T("Scope query thresholds fail!")},
    // Aux Sniffer
    {_ERROR_PLUGIN_AUXSNIFFER_FILE_TYPE, _T("Open aux sniffer file fail!")},
    {_ERROR_PLUGIN_AUXSNIFFER_USER_STOP, _T("Aux Sniffer user stop!")},

    // Acer EDID
    {_ERROR_ACEREDID_READ_EXTERNAL_FAIL, _T("Read external EDID fail!")},
    {_ERROR_ACEREDID_READ_INTERNAL_FAIL, _T("Read internal EDID fail!")},
    {_ERROR_ACEREDID_READ_BOTH_FAIL, _T("Read external EDID fail!  Read internal fail!")},

    //plungin gamma
    {_ERROR_PLUGIN_GAMMA_OPEN_FILE_FAIL, _T("Open Gamma File Fail!")},
    {_ERROR_PLUGIN_GAMMA_CHECK_DATA_FAIL, _T("Check Gamma Data Fail!")},
    {_ERROR_PLUGIN_GAMMA_SAVE_FILE_FAIL, _T("Save Gamma File Fail!")},

    {_ERROR_COMM_GFXI2C_INIT_FAIL, _T("Graphics I2C Init fail!")},
    {_ERROR_COMM_GFXI2C_PARAMETER, _T("Graphics I2C Invalid Parameter!")},
    {_ERROR_COMM_GFXI2C_READ_FAIL, _T("Graphics I2C Read fail!")},
    {_ERROR_COMM_GFXI2C_WRITE_FAIL, _T("Graphics I2C Write fail!")},
    {_ERROR_COMM_GFXI2C_NOT_SUPPORT, _T("Graphics I2C Not Support!")},
    {_ERROR_COMM_GFXI2C_I2C_PAGELENGTH, _T("Graphics I2C Pagelength UnSupport!")},

    {_ERROR_SOCKET_INIT_SOCKET_FAIL, _T("Init socket fail!")},
    {_ERROR_SOCKET_CONNECT_TO_SERVER_FAIL, _T("Connect to server fail!")},

    {_ERROR_GPIO_I2C_WRITE_FAIL, _T("GPIO Simulate I2C Write fail!")},
    {_ERROR_GPIO_I2C_READ_FAIL, _T("GPIO Simulate I2C Read fail!")},
    {_ERROR_DDCCI_ACCESS_TIME_OUT, _T("DDCCI Access Timeout!")},
    {_ERROR_DDCCI_CHECK_DATA_FAIL, _T("DDCCI Check Data Fail!")},
    {_ERROR_DATA_OUT_OF_SECTOR, _T("Data Length Out of Sector!")},
    {_ERROR_NOT_SUPPORT_DDCCI, _T("Not Support DDCCI Method!")},


    {_ERROR_HDCP_DEBUG_MODE_ERROR, _T("HDCP Debug Mode Error!")},
    {_ERROR_HDCP_DATA_CHECK_ERROR, _T("HDCP Data Check ERROR!")},
    {_ERROR_HDCP_NO_FILE_PATH, _T("No HDCP File Path!")},
    {_ERROR_PLUGIN_HDCP_CMD_ILLEGAL, _T("HDCP Command illegal!")},
    {_ERROR_HDCP_FILE_LEN_ERROR, _T("HDCP File Len Error!")},

    {_ERROR_LVDSVERIFY_NO_GT_FILE, _T("GT file is not exit!")},
    {_ERROR_LVDSVERIFY_GT_FILE_ILLEGAL, _T("GT file is illegal!")},
    {_ERROR_LVDSVERIFY_CREATE_TEST_DATA, _T("Create test data excel file fail!")},
    {_ERROR_LVDSVERIFY_CREATE_REPORT_FILE, _T("Create report file fail!")},

    {_ERROR_PLLVERIFY_NO_GT_FILE, _T("GT file is not exit!")},
    {_ERROR_PLLVERIFY_GT_FILE_ILLEGAL, _T("GT file is illegal!")},

    {_ERROR_PG_ERROR_TIMING, _T("Pattern Gen Wrong Timing!")},
    {_ERROR_PG_CHECK_PATTERN_VALUE, _T("Check Pattern Value Error!")},

    {_ERROR_PLUGIN_MSTDEBUG_ILLEGAL_DELAY, _T("Illegal delay time!")},
    {_ERROR_PLUGIN_MSTDEBUG_ILLEGAL_FIFO_DATA, _T("Illegal of FIFO data!")},

    {_ERROR_COMM_USBDHUBI2C_NOT_SUPPORT, _T("USB Hub I2C Not support!")},
    {_ERROR_COMM_USBDHUBI2C_INIT_FAIL, _T("USB Hub I2C Init Fail!")},
    {_ERROR_COMM_USBDHUBI2C_LOAD_DLL_FAIL, _T("USB Hub I2C Load Dll Fail!")},
    {_ERROR_COMM_USBDHUBI2C_GET_FUNC_FAIL, _T("USB Hub I2C Get Function Fail!")},
    {_ERROR_COMM_USBDHUBI2C_NO_AVAILABLE_DEV, _T("USB Hub I2C No Available Dev!")},
    {_ERROR_COMM_USBDHUBI2C_INVALID_PARAMETER, _T("USB Hub I2C Invalid Patameter!")},
    {_ERROR_COMM_USBDHUBI2C_I2C_PAGELENGTH_UNSUPPORT, _T("USB Hub I2C Page Length Not Support!")},
    {_ERROR_COMM_USBDHUBI2C_OPEN_DEV, _T("USB Hub Open Dev!")},
    {_ERROR_COMM_USBDHUBI2C_SETBUSSPEED, _T("USB Hub Set Bus Speed!")},
    {_ERROR_COMM_USBDHUBI2C_WRITEI2C, _T("USB Hub Wrtie I2C Error!")},
    {_ERROR_COMM_USBDHUBI2C_READI2C, _T("USB Hub Read I2C Error!")},

    {_ERROR_PLUGIN_TRIM_OPENFILE, _T("Open File Fail!")},
    {_ERROR_PLUGIN_TRIM_FILETYPE, _T("File Type Error!")},
    {_ERROR_PLUGIN_TRIM_MALLOCBUF, _T("Malloc Buffer Error!")},
    {_ERROR_PLUGIN_TRIM_BUF_NULL, _T("Buffer is NULL!")},

    {_ERROR_PLUGIN_DONGLEISP_ITEM_CNT_ILLEGAL, _T("Item count is illegal!")},
    {_ERROR_PLUGIN_DONGLEISP_MP_UI_SETTING, _T("Select a item to isp!")},
    {_ERROR_PLUGIN_DONGLEISP_MP_TRANSLATOR_OPEN_FAIL, _T("Open transaltor fw file fail!")},
    {_ERROR_PLUGIN_DONGLEISP_MP_TRANSLATOR_SIZE, _T("Transaltor fw size is illegal!")},
    {_ERROR_PLUGIN_DONGLEISP_MP_UFP_OPEN_FAIL, _T("Open UFP fw file fail!")},
    {_ERROR_PLUGIN_DONGLEISP_MP_UFP_SIZE, _T("UFP fw size is illegal!")},
    {_ERROR_PLUGIN_DONGLEISP_MP_EMPTY_BANK,_T("No data in flash bank 1")},
    {_ERROR_PLUGIN_DONGLEISP_MP_NO_HDCP_KEY, _T("No HDCP Key!")},
    {_ERROR_PLUGIN_DONGLEISP_MP_JUDGE_IC_FAIL, _T("Type judge fail!")},
    {_ERROR_PLUGIN_DONGLEISP_MP_JUDGE_C2HDMI_ONLY, _T("For RTD2171U (C2HDMI) Only!")},
    {_ERROR_PLUGIN_DONGLEISP_MP_JUDGE_C2VGA_ONLY, _T("For RTD2169U (C2VGA) Only!")},
    {_ERROR_PLUGIN_DONGLEISP_MP_WRITE_PID_VID_FAIL, _T("Write USB PID VID fail!")},
    {_ERROR_PLUGIN_DONGLEISP_MP_LACK_OF_FW_FILE, _T("Lack Of fw file!")},
    {_ERROR_PLUGIN_DONGLEISP_MP_ISP_CMD_ERROR, _T("Command after ISP error!")},


    {_ERROR_PLUGIN_READ_PUB_KEY_PARA_ILLEGAL, _T("Public key parameter illegal!")},
    {_ERROR_PLUGIN_READ_PUB_KEY_ILLEGAL_HEADER, _T("Public key header is not RTK!")},
    {_ERROR_PLUGIN_READ_PUB_KEY_ILLEGAL_LEN, _T("Public key length illegal!")},
    {_ERROR_PLUGIN_READ_PUB_KEY_CKSM_FIAL, _T("Public key check checksum fail!")},

    {_ERROR_PLUGIN_CRCDEBUG_JUDGE_RX_SOURCE_FAIL, _T("Judge rx source fail!")},
    {_ERROR_PLUGIN_CRCDEBUG_USER_CANCEL_READING, _T("User cancel read progress!")},

    {_ERROR_COMM_TYPECI2C_NOT_SUPPORT, _T("TypeC I2C Not support!")},
    {_ERROR_COMM_TYPECI2C_INIT_FAIL, _T("TypeC I2C Init Fail!")},
    {_ERROR_COMM_TYPECI2C_LOAD_DLL_FAIL, _T("TypeC I2C Load Dll Fail!")},
    {_ERROR_COMM_TYPECI2C_GET_FUNC_FAIL, _T("TypeC I2C Get Function Fail!")},
    {_ERROR_COMM_TYPECI2C_NO_AVAILABLE_DEV, _T("TypeC I2C No Available Dev!")},
    {_ERROR_COMM_TYPECI2C_INVALID_PARAMETER, _T("TypeC I2C Invalid Patameter!")},
    {_ERROR_COMM_TYPECI2C_I2C_PAGELENGTH_UNSUPPORT, _T("TypeC I2C Page Length Not Support!")},
    {_ERROR_COMM_TYPECI2C_OPEN_DEV, _T("TypeC Open Dev!")},
    {_ERROR_COMM_TYPECI2C_SETBUSSPEED, _T("TypeC Set Bus Speed!")},
    {_ERROR_COMM_TYPECI2C_WRITEI2C, _T("TypeC Wrtie I2C Error!")},
    {_ERROR_COMM_TYPECI2C_READI2C, _T("TypeC Read I2C Error!")},

    {_ERROR_COMM_TYPECUSB_NO_AVAILABLE_DEV, _T("No Available Device!")},
    {_ERROR_COMM_TYPECUSB_OPEN_DEV, _T("Open Type-C Usb Device Fail!")},
    {_ERROR_COMM_TYPECUSB_INIT_FAIL, _T("Type-C Usb Device Init Fail!")},
    {_ERROR_COMM_TYPECUSB_READ_REG, _T("Type-C Usb Read Register Fail!")},
    {_ERROR_COMM_TYPECUSB_WRITE_REG, _T("Type-C Usb Write Register Fail!")},
    {_ERROR_COMM_TYPECUSB_WRITE_FLASH_DATA, _T("Type-C Usb Write Flash Data Fail!")},
    {_ERROR_COMM_TYPECUSB_READ_FLASH_DATA, _T("Type-C Usb Read Flash Data Fail!")},
    {_ERROR_COMM_TYPECUSB_NOT_SUPPORT, _T("Type-C Usb Not Support!")},
    {_ERROR_COMM_TYPECUSB_WRITE_SYSEEPROM_FAIL, _T("Type-C Usb Write Systerm Eeprom Fail!")},
    {_ERROR_COMM_TYPECUSB_READ_SYSEEPROM_FAIL, _T("Type-C Usb Read Systerm Eeprom Fail!")},
    {_ERROR_COMM_TYPECUSB_HANDSHAKE_ERROR, _T("Type-C Usb Device Handshake Fail!")},
    {_ERROR_COMM_TYPECUSB_SELECT_DEV, _T("Type-C Usb Select Device Fail!")},
    {_ERROR_COMM_TYPECUSB_DM_EVENT_START, _T("Type-C Usb Start DebugMessage Event Fail!")},
    {_ERROR_COMM_TYPECUSB_DM_EVENT_FINISH, _T("Type-C Usb Finish DebugMessage Event Fail!")},
    {_ERROR_COMM_TYPECUSB_DM_START, _T("Type-C Usb Start DebugMessage Fail!")},
    {_ERROR_COMM_TYPECUSB_DM_END, _T("Type-C Usb End DebugMessage Fail!")},
    {_ERROR_COMM_TYPECUSB_DM_GET_VALUE, _T("Type-C Usb Get DebugMessage Value Fail!")},
    {_ERROR_COMM_TYPECUSB_DM_GET_STRING, _T("Type-C Usb Get DebugMessage String Fail!")},
    {_ERROR_COMM_TYPECUSB_SEND_PACKET_FAIL, _T("Type-C Usb send usb packet Fail!")},
    {_ERROR_COMM_TYPECUSB_RECEIVE_PACKET_FAIL, _T("Type-C Usb receive usb packet Fail!")},

    {_ERROR_PLUGIN_AUXISPBOARD_MORETHAN_ONE_LOCAL_FW_MEET, _T("Find more than one local fw!")},
    {_ERROR_PLUGIN_AUXISPBOARD_NOT_FIND_LOCAL_FW_FILE, _T("Not find local fw file!")},
    {_ERROR_PLUGIN_AUXISPBOARD_MORETHAN_ONE_PROGRAM_SCALER_FW_MEET, _T("Find more than one program scaler fw!")},
    {_ERROR_PLUGIN_AUXISPBOARD_MORETHAN_ONE_PROGRAM_UFP_FW_MEET, _T("Find more than one program UFP fw!")},
    {_ERROR_PLUGIN_AUXISPBOARD_MORETHAN_ONE_PROGRAM_DFP_FW_MEET, _T("Find more than one program DFP fw!")},
    {_ERROR_PLUGIN_AUXISPBOARD_ILLEGAL_PROGRAM_SCALER_FW, _T("Illegal program scaler fw!")},
    {_ERROR_PLUGIN_AUXISPBOARD_OPEN_LOCAL_FW_FAIL, _T("Open local fw fail!")},
    {_ERROR_PLUGIN_AUXISPBOARD_OPEN_PROGRAM_SCALER_FW_FAIL, _T("Open program scaler fw fail!")},
    {_ERROR_PLUGIN_AUXISPBOARD_OPEN_PROGRAM_UFP_FW_FAIL, _T("Open program UFP fw fail!")},
    {_ERROR_PLUGIN_AUXISPBOARD_OPEN_PROGRAM_DFP_FW_FAIL, _T("Open program DFP fw fail!")},
    {_ERROR_PLUGIN_AUXISPBOARD_ILLEGAL_LOCAL_BIN_SIZE, _T("Illegal local fw bin size!")},
    {_ERROR_PLUGIN_AUXISPBOARD_ILLEGAL_LOCAL_BIN_BANK2, _T("Illegal local fw bin of bank2!")},
    {_ERROR_PLUGIN_AUXISPBOARD_ILLEGAL_PROGRAM_SCALER_BIN_SIZE, _T("Illegal progran scaler fw bin size!")},
    {_ERROR_PLUGIN_AUXISPBOARD_ILLEGAL_PROGRAM_UFP_BIN_SIZE, _T("Illegal progran UFP fw bin size!")},
    {_ERROR_PLUGIN_AUXISPBOARD_ILLEGAL_PROGRAM_DFP_BIN_SIZE, _T("Illegal progran DFP fw bin size!")},
    {_ERROR_PLUGIN_AUXISPBOARD_ILLEGAL_PROGRAM_FW, _T("Illegal progran FW!")},
    {_ERROR_PLUGIN_AUXISPBOARD_UNKNOWN_PROGRAM_TYPE, _T("Unknown program type!")},

    {_ERROR_PLUGIN_DDR_SPACE_WRTIE, _T("Register can't be writtern!")},

    {_ERROR_PLUGIN_ERROR_COUNT_COMM_NOT_SUPPORT, _T("Access method is not support native read.")},
    {_ERROR_PLUGIN_ERROR_COUNT_SCALER_NOT_SUPPORT, _T("Scaler type is not support.")},
    {_ERROR_PLUGIN_ERROR_COUNT_LANE_COUNT_ERROR, _T("Read lane count error.")},

    {_ERROR_RS232_INITIAL_FAIL,_T("COM port initial fail!")},
    {_ERROR_RS232_INSTRUMNET_NO_ACK,_T("Instrumnet no ack from COM port!")},

    {_ERROR_NETWORK_INITIAL_FAIL,_T("Network initial fail!")},
    {_ERROR_NETWORK_INSTRUMNET_NO_ACK,_T("Instrumnet no ack from Network!")},

    {_ERROR_RSAUTOTEST_HDMI_NOT_SUPPORT, _T("HDMI Port don't support this function!")},
    {_ERROR_RSAUTOTEST_DP_VERSION_NOT_SUPPORT, _T("DP Version don't support!")},
    {_ERROR_RSAUTOTEST_DP_NOT_SUPPORT, _T("DP Port don't support!")},
    {_ERROR_RSAUTOTEST_OUTPUT_DVS_TSET_SIGNAL_FAIL, _T("Output DVS test signal fail!")},

    {_ERROR_PLUGIN_GETFEVERSION_FWVER_COMPARE_FAIL, _T("FW Version Compare fail!")},
    {_ERROR_PLUGIN_GETFEVERSION_USB_COMPARE_FAIL, _T("USB PID VID Compare fail!")},
    {_ERROR_PLUGIN_GETFEVERSION_PDCC_COMPARE_FAIL, _T("PDCC PID VID Compare fail!")},
    {_ERROR_PLUGIN_GETFEVERSION_STRING_COMPARE_FAIL, _T("Manufacture / Product Compare fail!")},

    {_ERROR_COMM_GLHUBI2C_NOT_SUPPORT, _T("GLHub I2C Not support!")},
    {_ERROR_COMM_GLHUBI2C_INIT_FAIL, _T("GLHub I2C Init Fail!")},
    {_ERROR_COMM_GLHUBI2C_LOAD_DLL_FAIL, _T("GLHub I2C Load Dll Fail!")},
    {_ERROR_COMM_GLHUBI2C_GET_FUNC_FAIL, _T("GLHub I2C Get Function Fail!")},
    {_ERROR_COMM_GLHUBI2C_NO_AVAILABLE_DEV, _T("GLHub I2C No Available Dev!")},
    {_ERROR_COMM_GLHUBI2C_INVALID_PARAMETER, _T("GLHub I2C Invalid Patameter!")},
    {_ERROR_COMM_GLHUBI2C_I2C_PAGELENGTH_UNSUPPORT, _T("GLHub I2C Page Length Not Support!")},
    {_ERROR_COMM_GLHUBI2C_OPEN_DEV, _T("GLHub Open Dev!")},
    {_ERROR_COMM_GLHUBI2C_SETBUSSPEED, _T("GLHub Set Bus Speed!")},
    {_ERROR_COMM_GLHUBI2C_WRITEI2C, _T("GLHub Wrtie I2C Error!")},
    {_ERROR_COMM_GLHUBI2C_READI2C, _T("GLHub Read I2C Error!")},

    {_ERROR_COMM_VIAHUBI2C_NOT_SUPPORT, _T("VIAHUB I2C Not support!")},
    {_ERROR_COMM_VIAHUBI2C_INIT_FAIL, _T("VIAHUB I2C Init Fail!")},
    {_ERROR_COMM_VIAHUBI2C_LOAD_DLL_FAIL, _T("VIAHUB I2C Load Dll Fail!")},
    {_ERROR_COMM_VIAHUBI2C_GET_FUNC_FAIL, _T("VIAHUB I2C Get Function Fail!")},
    {_ERROR_COMM_VIAHUBI2C_NO_AVAILABLE_DEV, _T("VIAHUB I2C No Available Dev!")},
    {_ERROR_COMM_VIAHUBI2C_INVALID_PARAMETER, _T("VIAHUB I2C Invalid Patameter!")},
    {_ERROR_COMM_VIAHUBI2C_I2C_PAGELENGTH_UNSUPPORT, _T("VIAHUB I2C Page Length Not Support!")},
    {_ERROR_COMM_VIAHUBI2C_OPEN_DEV, _T("VIAHUB Open Dev!")},
    {_ERROR_COMM_VIAHUBI2C_SETBUSSPEED, _T("VIAHUB Set Bus Speed!")},
    {_ERROR_COMM_VIAHUBI2C_WRITEI2C, _T("VIAHUB Wrtie I2C Error!")},
    {_ERROR_COMM_VIAHUBI2C_READI2C, _T("VIAHUB Read I2C Error!")},
    {_ERROR_COMM_VIAHUBI2C_READ_EXCEED_MAX_LENGTH, _T("VIAHUB Read Exceed Max Length!")},
    {_ERROR_COMM_VIAHUBI2C_WRITE_EXCEED_MAX_LENGTH, _T("VIAHUB Write Exceed Max Length!")},
    {_ERROR_COMM_VIAHUBI2C_READ_LENGTH_INVALID, _T("VIAHUB Read Length Invalid!")},
    {_ERROR_COMM_VIAHUBI2C_WRITE_LENGTH_INVALID, _T("VIAHUB Write Length Invalid!")},

    {_ERROR_PLUGIN_PHY_CHECK_MAC_FAIL, _T("Check PHY for which MAC0 / MAC1 fail!")},
    {_ERROR_PLUGIN_PHY_DETECT_VSYNC_TIME_OUT, _T("Detect Vsync time out!")},
    
    {_ERROR_CPDEVICECOMM_NOT_SUPPORT, _T("Device don't support this function!")},
    
    {_ERROR_LINUX_I2C_INIT_FAIL, _T("Linux i2c device init fial!")},
    {_ERROR_LINUX_I2C_SET_SLAVE_ADDRESS, _T("Set i2c slave address fail!")},
    {_ERROR_LINUX_I2C_WRITE_FAIL, _T("I2C write data fail!")},
    {_ERROR_LINUX_I2C_READ_FAIL, _T("I2C read data fail!")},

    {_ERROR_END, _T("No information of this error!")}
};
